<template>
    <div class="flex flex-col m-2 bg-gray-200 p-2">
        <div class="headline flex flex-row items-center mb-2">
            <div class="flex-grow text-md uppercase"> Projects <span class="px-2 text-xs bg-gray-500 text-gray-100 mx-2 rounded-full">{{projects.length}}</span> </div>
            <div class="actions">
                <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="create()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                    <span>Add Project</span>
                </button>
            </div>
        </div>
        <div class="w-full bg-white">
            <table class="relative table-auto w-full">
                <thead>
                    <tr class="border-b border-gray-200">
                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Id</th>
                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Project</th>
                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Counts</th>
                        <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Actions</th>
                    </tr>
                </thead>
                <tbody class="bg-white overflow-y-auto w-full">
                    <tr :class="{'bg-gray-100': index % 2, 'bg-white': !(index % 2)}" v-for="(project, index) in projects" :key="project.id">
                        <td class="px-2 py-2 whitespace-no-wrap">
                            <div class="flex flex-col items-center content-center">
                                <div class="px-2 rounded-full mt-2">
                                    <span class="text-xs">{{project.id}}</span>
                                </div>
                            </div>
                        </td>
                        <td class="px-2 py-2 whitespace-no-wrap">
                            <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full">{{project.name}}</div>
                            <div class="text-sm leading-5 text-gray-900 whitespace-pre-line w-full">{{project.label}}</div>
                        </td>
                        <td class="px-2 py-2 whitespace-no-wrap">
                            <div class="text-sm leading-5 text-gray-700 whitespace-pre-line inline-block float-left mr-2"><span class="text-gray-900">{{project.reports}}</span> reports</div>
                            <div class="text-sm leading-5 text-gray-700 whitespace-pre-line inline-block float-left mr-2"><span class="text-gray-900">{{project.types}}</span> types</div>
                        </td>
                        <td class="px-2 py-2 whitespace-no-wrap">
                            <button class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="edit(project)">
                                <img svg-inline src="./pix/zond/edit-pencil.svg" class="w-4 h-4 fill-current" />
                            </button>
                            <button class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="visit(project)">
                                <img svg-inline src="./pix/zond/network.svg" class="w-4 h-4 fill-current" />
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <wee-spatial-project-info v-if="creating" :project="emptyProject" v-on:created="created"></wee-spatial-project-info>
    </div>
</template>
<script>
import axios from 'axios'
import axiosCancel from 'axios-cancel';
import WeeSpatialProjectInfo from './WeeSpatialProjectInfo'
import {ThemeMixin} from './themes.js';
import './style.css';

axiosCancel(axios, {
    debug: false // default
});

export default {
    name: "WeeSpatialProjects",
    props: [],
    components: {
        WeeSpatialProjectInfo
    },
    data(){
        return {
            creating: false,
            projects: [],
            emptyProject: {
                id: 0,
                name: '',
                label: '',
                description: '',
                properties: {
                    color: 'teal',
                    universe: [{key: 'country'}, {key: 'locality'}],
                    common: [{key: 'locality'}]
                },
                reports: 0,
                types: []
            }
        };
    },
    created(){
        this.load();
    },
    methods: {
        load(){
            let self = this;
            axios.get(this.projectsUrl).then(function(response){
                self.projects = response.data.projects;
            }).catch(function(error){
                console.log(error);
            });
        },
        reload(){
            this.load();
        },
        edit(p){
            this.$emit('select', p);
        },
        create(){
            this.creating = true;
        },
        created(){
            this.creating = false;
            this.reload();
        }
    },
    computed: {
        projectsUrl: function(){
            return '/admin/mutables';
        }
    }
}
</script>
<style>

</style>
